//
// Generated by SwagGen
// https://github.com/yonaskolb/SwagGen
//

import Foundation
import JSONUtilities

extension API.Pet {

    /** Returns a single pet */
    public enum GetPetById {

      public static let service = APIService<Response>(id: "getPetById", tag: "pet", method: "GET", path: "/pet/{petId}", hasBody: false, authorization: Authorization(type: "api_key", scope: ""))

      public class Request: APIRequest<Response> {

          public struct Options {

              /** ID of pet to return */
              public var petId: Int

              public init(petId: Int) {
                  self.petId = petId
              }
          }

          public var options: Options

          public init(options: Options) {
              self.options = options
              super.init(service: GetPetById.service)
          }

          /// convenience initialiser so an Option doesn't have to be created
          public convenience init(petId: Int) {
              let options = Options(petId: petId)
              self.init(options: options)
          }

          public override var path: String {
              return super.path.replacingOccurrences(of: "{" + "petId" + "}", with: "\(self.options.petId)")
          }
        }

        public enum Response: APIResponseValue, CustomStringConvertible, CustomDebugStringConvertible {
            public typealias SuccessType = Pet

            /** successful operation */
            case success200(Pet)

            /** Invalid ID supplied */
            case failure400

            /** Pet not found */
            case failure404

            public var success: Pet? {
                switch self {
                case .success200(let response): return response
                default: return nil
                }
            }

            public var response: Any {
                switch self {
                case .success200(let response): return response
                default: return ()
                }
            }

            public var statusCode: Int {
              switch self {
              case .success200: return 200
              case .failure400: return 400
              case .failure404: return 404
              }
            }

            public var successful: Bool {
              switch self {
              case .success200: return true
              case .failure400: return false
              case .failure404: return false
              }
            }

            public init(statusCode: Int, data: Data) throws {
                switch statusCode {
                case 200: self = try .success200(JSONDecoder.decode(data: data))
                case 400: self = .failure400
                case 404: self = .failure404
                default: throw APIError.unexpectedStatusCode(statusCode: statusCode, data: data)
                }
            }

            public var description: String {
                return "\(statusCode) \(successful ? "success" : "failure")"
            }

            public var debugDescription: String {
                var string = description
                let responseString = "\(response)"
                if responseString != "()" {
                    string += "\n\(responseString)"
                }
                return string
            }
        }
    }
}
